import zLOG

from threading import Thread, Event
import datetime

class Timer(object):
    def __init__(self, callback):
        self.__callback = callback
        self.__thread = None
        self.__change = Event()
        self.__ending = Event()
    
    def start(self):
        self.__change.clear()
        self.__thread = Thread(target = self.__run)
        self.__thread.start()
    
    def change(self):
        self.__change.set()
    
    def restart(self):
        if self.running():
            self.stop()
        self.start()
    
    def stop(self):
        self.__ending.clear()
        self.__thread = None
        self.__change.set()
        self.__ending.wait(5)
    
    def running(self):
        return self.__thread is not None and self.__thread.isAlive()
    
    def lastTime(self):
        return self.__lastTime
    
    def __run(self):
        while self.__thread is not None:
            try:
                timeout = self.__callback()
                self.__lastTime = datetime.datetime.now()
            except Exception, e:
                zLOG.LOG('ZpCron', zLOG.ERROR, 'Exception in timer callback execution')
                zLOG.LOG('ZpCron', zLOG.ERROR, e)
                timeout = 60
            if timeout > 0:
                self.__change.wait(timeout)
        self.__ending.set()
